#!/bin/bash
LANG=en_US.utf8
LC_ALL=en_US.utf8
unameout="$(uname -s)"

mn=`date +"%b"`
yr=`date +"%Y"`
let nyr=$yr+1

for ld in 1; do

if [ $ld = 1 ]; then

if [ $mn == "Jan" ]; then prd='FMA'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='MAM'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Sep" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Oct" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Nov" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Dec" ]; then prd='JFM'; yrr=$nyr ; fi
fi

if [ $ld = 2 ]; then

if [ $mn == "Jan" ]; then prd='MAM'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Sep" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Oct" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Nov" ]; then prd='JFM'; yrr=$nyr ; fi
if [ $mn == "Dec" ]; then prd='FMA'; yrr=$nyr ; fi
fi


if [ $ld = 3 ]; then

if [ $mn == "Jan" ]; then prd='AMJ'; yrr=$yr ; fi
if [ $mn == "Feb" ]; then prd='MJJ'; yrr=$yr ; fi
if [ $mn == "Mar" ]; then prd='JJA'; yrr=$yr ; fi
if [ $mn == "Apr" ]; then prd='JAS'; yrr=$yr ; fi
if [ $mn == "May" ]; then prd='ASO'; yrr=$yr ; fi
if [ $mn == "Jun" ]; then prd='SON'; yrr=$yr ; fi
if [ $mn == "Jul" ]; then prd='OND'; yrr=$yr ; fi
if [ $mn == "Aug" ]; then prd='NDJ'; yrr=$yr/$nyr ; fi
if [ $mn == "Sep" ]; then prd='DJF'; yrr=$yr/$nyr ; fi
if [ $mn == "Oct" ]; then prd='JFM'; yrr=$nyr ; fi
if [ $mn == "Nov" ]; then prd='FMA'; yrr=$nyr ; fi
if [ $mn == "Dec" ]; then prd='MAM'; yrr=$nyr ; fi
fi

rm train_data/nmme_ld_${ld}_tercile.nc
wget --no-check-certificate https://ftp.cpc.ncep.noaa.gov/International/PREPARE_africa/seasonal/data/$mn/nmme_ld_${ld}_tercile.nc
mv nmme_ld_${ld}_tercile.nc train_data/

cat>gen_ens.py<<eofPY
#!/usr/bin/env python
# coding: utf-8

import xcast as xc
import xarray as xr
import cartopy.crs as ccrs
import numpy as np
import matplotlib.pyplot as plt
#import rioxarray
#import geopandas as gpd
from shapely.geometry import mapping

wlon=$1
elon=$2
slat=$3
nlat=$4


longrid = np.arange(wlon, elon + 10,10)
latgrid = np.arange(slat, nlat + 10,10)

longridl = longrid.tolist()
latgridl = latgrid.tolist()

fmodel1 = xr.open_dataset('train_data/nmme_ld_${ld}_tercile.nc')
fmodel = fmodel1.precip
fmodel = fmodel.sel(lon=slice(wlon, elon), lat=slice(slat,nlat))

import matplotlib.ticker as mticker
from cartopy.mpl.gridliner import LONGITUDE_FORMATTER, LATITUDE_FORMATTER

import sys
sys.path.append('./libs')

from prob import pview_probabilistic
ax = pview_probabilistic(fmodel.isel(time=0), ocean=False, title='NMME Raw Precip Forecast, Valid: ${prd} ${yrr}')
gl = ax.gridlines(crs=ccrs.PlateCarree(), linewidth=1, color='blue', alpha=0.5, linestyle='--', draw_labels=True)
gl.top_labels = False
gl.left_labels = False
gl.right_labels=True
gl.xlines = True
gl.xlocator = mticker.FixedLocator(longridl)
gl.ylocator = mticker.FixedLocator(latgridl)
gl.xformatter = LONGITUDE_FORMATTER
gl.yformatter = LATITUDE_FORMATTER
gl.xlabel_style = {'color': 'black'}
gl.top_labels = False
gl.left_labels = True
gl.right_labels=False
gl.bottom_labels=True
plt.savefig('fig_dir/nmme_raw_lead_${ld}.png', dpi=300)

eofPY

python gen_ens.py

convert -trim fig_dir/nmme_raw_lead_${ld}.png fig_dir/nmme_raw_lead_${ld}.png
convert -bordercolor white -border 10 fig_dir/nmme_raw_lead_${ld}.png fig_dir/nmme_raw_lead_${ld}.png

done
